/*
 */
package booknaviger.inet.htmlreport;

import java.util.ResourceBundle;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Interface for the progress of the html report
 * @author Inervo
 */
public class GenerationProgress extends javax.swing.JDialog {
    
    ReportGenerator htmlReport = null;
    ResourceBundle resourceBundle = ResourceBundle.getBundle("booknaviger/resources/GenerationProgress");

    /**
     * Creates new form GenerationProgress
     */
    public GenerationProgress(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        Logger.getLogger(GenerationProgress.class.getName()).entering(GenerationProgress.class.getName(), "GenerationProgress", new Object[] {parent, modal});
        initComponents();
        this.setLocationRelativeTo(this.getParent());
        Logger.getLogger(GenerationProgress.class.getName()).exiting(GenerationProgress.class.getName(), "GenerationProgress");
    }

    /**
     * This method is called from within the constructor to initialize the
     * form. WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        logoLabel = new javax.swing.JLabel();
        infoLabel = new javax.swing.JLabel();
        actionLabel = new javax.swing.JLabel();
        actionProgressBar = new javax.swing.JProgressBar();
        cancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        logoLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        logoLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/booknaviger/resources/graphics/infologos/info.png"))); // NOI18N

        infoLabel.setText(resourceBundle.getString("infoLabelString")); // NOI18N

        actionProgressBar.setStringPainted(true);

        cancelButton.setText(resourceBundle.getString("cancelButtonString")); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(logoLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 69, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(infoLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 325, Short.MAX_VALUE))
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(actionLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(actionProgressBar, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(0, 0, Short.MAX_VALUE)
                        .add(cancelButton)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(infoLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(logoLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 60, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(actionLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 30, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(actionProgressBar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(cancelButton)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Event received when wanting to cancel the reporting
     * @param evt the event associated
     */
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        Logger.getLogger(GenerationProgress.class.getName()).entering(GenerationProgress.class.getName(), "cancelButtonActionPerformed");
        cancel();
        Logger.getLogger(GenerationProgress.class.getName()).exiting(GenerationProgress.class.getName(), "cancelButtonActionPerformed");
    }//GEN-LAST:event_cancelButtonActionPerformed

    /**
     * Cancel the html reporting
     */
    private void cancel() {
        Logger.getLogger(GenerationProgress.class.getName()).entering(GenerationProgress.class.getName(), "cancel");
        htmlReport.setCancelAsked(true);
        setVisible(false);
        dispose();
        Logger.getLogger(GenerationProgress.class.getName()).log(Level.INFO, "The cancel of the HTML report has been asked");
        Logger.getLogger(GenerationProgress.class.getName()).exiting(GenerationProgress.class.getName(), "cancel");
    }
    
    /**
     * Set the ReportGenerator instance
     * @param htmlReport ReportGenerator instance
     */
    public void setHtmlReport(ReportGenerator htmlReport) {
        Logger.getLogger(GenerationProgress.class.getName()).entering(GenerationProgress.class.getName(), "setHtmlReport", htmlReport);
        this.htmlReport = htmlReport;
        Logger.getLogger(GenerationProgress.class.getName()).exiting(GenerationProgress.class.getName(), "setHtmlReport");
    }

    /**
     * Set the value of the progressBar
     * @param value value of the progressBar
     */
    public void setActionProgressBarValue(int value) {
        Logger.getLogger(GenerationProgress.class.getName()).entering(GenerationProgress.class.getName(), "setActionProgressBarValue", value);
        this.actionProgressBar.setValue(value);
        Logger.getLogger(GenerationProgress.class.getName()).exiting(GenerationProgress.class.getName(), "setActionProgressBarValue");
    }

    /**
     * Get the progressBar value
     * @return Value of the progressBar
     */
    public int getActionProgressBarValue() {
        Logger.getLogger(GenerationProgress.class.getName()).entering(GenerationProgress.class.getName(), "getActionProgressBarValue");
        Logger.getLogger(GenerationProgress.class.getName()).exiting(GenerationProgress.class.getName(), "getActionProgressBarValue", this.actionProgressBar.getValue());
        return this.actionProgressBar.getValue();
    }

    /**
     * Set the text about the current action
     * @param value String of the action in progress
     */
    public void setActionLabelValue(String value) {
        Logger.getLogger(GenerationProgress.class.getName()).entering(GenerationProgress.class.getName(), "setActionLabelValue", value);
        this.actionLabel.setText("<html>" + value + "</html>");
        Logger.getLogger(GenerationProgress.class.getName()).exiting(GenerationProgress.class.getName(), "setActionLabelValue");
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel actionLabel;
    private javax.swing.JProgressBar actionProgressBar;
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel infoLabel;
    private javax.swing.JLabel logoLabel;
    // End of variables declaration//GEN-END:variables
}
