/*
 */
package booknaviger.inet.htmlreport;

import booknaviger.MainInterface;
import java.io.File;
import java.util.ResourceBundle;
import java.util.logging.Logger;
import javax.swing.SwingUtilities;

/**
 * Class to select the mode (simple or advance) of the html report
 * @author Inervo
 */
public class ReportModeSelector extends javax.swing.JDialog {
    
    ResourceBundle resourceBundle = ResourceBundle.getBundle("booknaviger/resources/ReportModeSelector");

    /**
     * Creates new form ReportModeSelector
     */
    public ReportModeSelector(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        Logger.getLogger(ReportModeSelector.class.getName()).entering(ReportModeSelector.class.getName(), "ReportModeSelector", new Object[] {parent, modal});
        initComponents();
        this.setLocationRelativeTo(this.getParent());
        Logger.getLogger(ReportModeSelector.class.getName()).exiting(ReportModeSelector.class.getName(), "ReportModeSelector");
    }

    /**
     * This method is called from within the constructor to initialize the
     * form. WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        modeButtonGroup = new javax.swing.ButtonGroup();
        logoLabel = new javax.swing.JLabel();
        infoLabel = new javax.swing.JLabel();
        simpleModeRadioButton = new javax.swing.JRadioButton();
        advanceModeRadioButton = new javax.swing.JRadioButton();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(resourceBundle.getString("Title")); // NOI18N

        logoLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        logoLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/booknaviger/resources/graphics/infologos/info.png"))); // NOI18N

        infoLabel.setText(resourceBundle.getString("infoLabel.text")); // NOI18N

        modeButtonGroup.add(simpleModeRadioButton);
        simpleModeRadioButton.setSelected(true);
        simpleModeRadioButton.setText(resourceBundle.getString("simpleModeRadioButton.text")); // NOI18N

        modeButtonGroup.add(advanceModeRadioButton);
        advanceModeRadioButton.setText(resourceBundle.getString("advanceModeRadioButton.text")); // NOI18N

        okButton.setText(resourceBundle.getString("okButton")); // NOI18N
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText(resourceBundle.getString("cancelButton")); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(logoLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 53, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(infoLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                                .add(0, 0, Short.MAX_VALUE)
                                .add(cancelButton)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(okButton))
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(simpleModeRadioButton)
                                    .add(advanceModeRadioButton))
                                .add(0, 0, Short.MAX_VALUE)))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(logoLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 45, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(infoLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(simpleModeRadioButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(advanceModeRadioButton)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(okButton)
                    .add(cancelButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Event received when the ok button is clicked
     * @param evt the event associated
     */
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        Logger.getLogger(ReportModeSelector.class.getName()).entering(ReportModeSelector.class.getName(), "okButtonActionPerformed");
        SwingUtilities.invokeLater(new Thread() {

            @Override
            public void run() {
                GenerationProgress generationProgressDialog = new GenerationProgress(MainInterface.getInstance(), false);
                generationProgressDialog.setVisible(true);
                ReportGenerator htmlReporter = new ReportGenerator(advanceModeRadioButton.isSelected(), new File(MainInterface.getInstance().getProfiles().getCurrentProfileFolder()), generationProgressDialog);
                generationProgressDialog.setHtmlReport(htmlReporter);
                htmlReporter.execute();
                Logger.getLogger(ReportModeSelector.class.getName()).exiting(ReportModeSelector.class.getName(), "okButtonActionPerformed");
            }
        });
        setVisible(false);
        dispose();
    }//GEN-LAST:event_okButtonActionPerformed

    /**
     * Event received when wanting to cancel the report
     * @param evt the event associated
     */
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        Logger.getLogger(ReportModeSelector.class.getName()).entering(ReportModeSelector.class.getName(), "cancelButtonActionPerformed");
        setVisible(false);
        dispose();
        Logger.getLogger(ReportModeSelector.class.getName()).exiting(ReportModeSelector.class.getName(), "cancelButtonActionPerformed");
    }//GEN-LAST:event_cancelButtonActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton advanceModeRadioButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JLabel infoLabel;
    private javax.swing.JLabel logoLabel;
    private javax.swing.ButtonGroup modeButtonGroup;
    private javax.swing.JButton okButton;
    private javax.swing.JRadioButton simpleModeRadioButton;
    // End of variables declaration//GEN-END:variables
}
