/*
 */
package booknaviger.inet.updater;

import booknaviger.osbasics.OSBasics;
import java.text.MessageFormat;
import java.util.ResourceBundle;
import java.util.logging.Logger;

/**
 * Class to the interface about the new version information
 * @author Inervo
 */
public class NewUpdateAvailableDialog extends javax.swing.JDialog {
    
    ResourceBundle resourceBundle = ResourceBundle.getBundle("booknaviger/resources/NewUpdateAvailableDialog");
    String versionNumber = "";
    String downloadURLString = "";

    /**
     * Creates new form NewUpdateAvailableDialog
     */
    public NewUpdateAvailableDialog(java.awt.Frame parent, String versionNumber, String downloadURLString) {
        super(parent, true);
        Logger.getLogger(NewUpdateAvailableDialog.class.getName()).entering(NewUpdateAvailableDialog.class.getName(), "NewUpdateAvailableDialog", new Object[] {parent, versionNumber, downloadURLString});
        setLocationRelativeTo(parent);
        this.versionNumber = versionNumber;
        this.downloadURLString = downloadURLString;
        initComponents();
        Logger.getLogger(NewUpdateAvailableDialog.class.getName()).exiting(NewUpdateAvailableDialog.class.getName(), "NewUpdateAvailableDialog");
    }

    /**
     * This method is called from within the constructor to initialize the
     * form. WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        logoLabel = new javax.swing.JLabel();
        newUpdateAvailableLabel = new javax.swing.JLabel();
        goButton = new javax.swing.JButton();
        laterButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(resourceBundle.getString("NewVersionDialogTitle")); // NOI18N

        logoLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        logoLabel.setIcon(new javax.swing.ImageIcon(getClass().getResource("/booknaviger/resources/graphics/infologos/info.png"))); // NOI18N

        newUpdateAvailableLabel.setText(MessageFormat.format(resourceBundle.getString("NewVersion.text"), ResourceBundle.getBundle("booknaviger/resources/Application").getString("appTitle"), versionNumber));

        goButton.setText(resourceBundle.getString("goButton.text")); // NOI18N
        goButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                goButtonActionPerformed(evt);
            }
        });

        laterButton.setText(resourceBundle.getString("laterButton")); // NOI18N
        laterButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                laterButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(0, 184, Short.MAX_VALUE)
                        .add(laterButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(goButton))
                    .add(layout.createSequentialGroup()
                        .add(logoLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 58, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(0, 0, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(newUpdateAvailableLabel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(logoLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 49, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(newUpdateAvailableLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 38, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(goButton)
                    .add(laterButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * Called when the latter button is pressed
     * @param evt The event associated
     */
    private void laterButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_laterButtonActionPerformed
        Logger.getLogger(NewUpdateAvailableDialog.class.getName()).entering(NewUpdateAvailableDialog.class.getName(), "laterButtonActionPerformed");
        exit();
        Logger.getLogger(NewUpdateAvailableDialog.class.getName()).exiting(NewUpdateAvailableDialog.class.getName(), "laterButtonActionPerformed");
    }//GEN-LAST:event_laterButtonActionPerformed

    /**
     * Called when the go button is pressed
     * @param evt The event associated
     */
    private void goButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_goButtonActionPerformed
        Logger.getLogger(NewUpdateAvailableDialog.class.getName()).entering(NewUpdateAvailableDialog.class.getName(), "goButtonActionPerformed");
        OSBasics.openURI(downloadURLString);
        exit();
        Logger.getLogger(NewUpdateAvailableDialog.class.getName()).exiting(NewUpdateAvailableDialog.class.getName(), "goButtonActionPerformed");
    }//GEN-LAST:event_goButtonActionPerformed

    /**
     * Exit this interface
     */
    private void exit() {
        Logger.getLogger(NewUpdateAvailableDialog.class.getName()).entering(NewUpdateAvailableDialog.class.getName(), "exit");
        this.setVisible(false);
        dispose();
        Logger.getLogger(NewUpdateAvailableDialog.class.getName()).exiting(NewUpdateAvailableDialog.class.getName(), "exit");
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton goButton;
    private javax.swing.JButton laterButton;
    private javax.swing.JLabel logoLabel;
    private javax.swing.JLabel newUpdateAvailableLabel;
    // End of variables declaration//GEN-END:variables
}
